_int8 colorbytes;
_int16 MAXY;
_int32 pixcolor;

void UpdateScreenFromBuffer(void)
{
	_int32 VI_STATUS_REG=(VIreg[0] << 24)+(VIreg[1] << 16)+(VIreg[2] << 8)+VIreg[3];
	_int32 VI_WIDTH_REG=(VIreg[0x8] << 24)+(VIreg[0x9] << 16)+(VIreg[0xA] << 8)+VIreg[0xB];
	_int32 VI_ORIGIN_REG=(VIreg[0x4] << 24)+(VIreg[0x5] << 16)+(VIreg[0x6] << 8)+VIreg[0x7];

	if(((VI_STATUS_REG<<30)>>30)==2)
	{
		colorbytes=2;
	}
	else
	{
		colorbytes=4;
	}

	if(VI_WIDTH_REG==320)
	{
		MAXY=240;
	}
	else
	{
		MAXY=480;
	}

	for(_int16 y=0;y<MAXY;y++)
	{
		for(_int16 x=0;x<VI_WIDTH_REG;x++)
		{
		if(colorbytes==4)
		{
		pixcolor=(RAM[(VI_ORIGIN_REG+((y*VI_WIDTH_REG+x)*colorbytes))] << 24)+
				 (RAM[(VI_ORIGIN_REG+((y*VI_WIDTH_REG+x)*colorbytes))+1] << 16)+
				 (RAM[(VI_ORIGIN_REG+((y*VI_WIDTH_REG+x)*colorbytes))+2] << 8)+
			      RAM[(VI_ORIGIN_REG+((y*VI_WIDTH_REG+x)*colorbytes))+3];
		SetPixelV(hDC, x,y, RGB((pixcolor>>24),((pixcolor<<8)>>24),((pixcolor<<16)>>24)));
		InvalidateRect(hWndMain,NULL,TRUE);
		}
		else
		{
		pixcolor=(RAM[(VI_ORIGIN_REG+((y*VI_WIDTH_REG+x)*colorbytes))] << 8)+
				 RAM[(VI_ORIGIN_REG+((y*VI_WIDTH_REG+x)*colorbytes))+1];
		SetPixelV(hDC, x,y, RGB((pixcolor>>11),((pixcolor<<5)>>11),((pixcolor<<10)>>11)));
		InvalidateRect(hWndMain,NULL,TRUE);
		}

		}
	}
}